<?php
/*
Plugin Name: First Contact Chatbots
Version: 1.0
Plugin URI: https://firstcontactchatbots.com
Description: Create easily in minutes a chatbot for your website!
Author: First Contact Chatbots.
License: GPLv2 or later
*/


require_once plugin_dir_path(__FILE__) . 'includes/fcch-functions.php';

add_action('admin_init', 'fcch_init_fcch_plugin');
add_action("wp_footer", "fcch_add_contents");

function fcch_add_contents()
{                            
  $settings = get_option('fcch-plugin-settings');

  if (is_array($settings) && array_key_exists('chatbotId', $settings))
  {
      $chatbotId = $settings['chatbotId'];
      $showOn = $settings['showOn'];
      $imageUrl = ($settings['imageUrl'] != "" ? $settings['imageUrl'] : plugins_url('/includes/chaticons.png', __FILE__));
      $chatbotAvatar = ($settings['chatbotAvatar'] != "" ? $settings['chatbotAvatar'] : plugins_url('/includes/chatbot_avatar.png', __FILE__));
      $panelColor = ($settings['panelColor'] != "" ? $settings['panelColor'] : "#25d366");
      
      if ($chatbotId != '')
      {
          if (($showOn === 'all') || ($showOn === 'home' && (is_home() || is_front_page())) || !$showOn === 'none')
          {
              
              echo '<div id="fcchChatbotWidget"></div>';
              
              wp_register_style( 'fcch-button-style', plugins_url('/includes/fcch-button.css', __FILE__) );
              wp_enqueue_style('fcch-button-style');
              
              wp_register_script( 'fcch-button-script', plugins_url('/includes/fcch-button.js', __FILE__), array('jquery'));
              wp_enqueue_script( 'fcch-button-script' );
                            
              wp_localize_script( 'fcch-button-script', 'fcch_array_params',
                    array( 
                        'chatbot_sid' => $chatbotId,
                        'image_url' => $imageUrl,
                        'chatbot_avatar' => $chatbotAvatar,
                        'panel_color' => $panelColor
                    )
                );                
          }
      }
  }            
}

function fcch_init_fcch_plugin(){
  register_setting('fcch-settings-group', 'fcch-plugin-settings');
  
  add_settings_field('chatbotId', 'Chatbot Id', 'trim', 'fcch');
  add_settings_field('imageUrl', 'Image Url', 'trim', 'fcch');
  add_settings_field('chatbotAvatar', 'Chatbot Avatar', 'trim', 'fcch');
  add_settings_field('panelColor', 'Panel Color', 'trim', 'fcch');
  add_settings_field('showOn', 'Show On', 'trim', 'fcch');
  
  $initialSettings = get_option('fcch-plugin-settings');
  if ($initialSettings === false)
  {
      $initialSettings['showOn'] = 'all';
      update_option('fcch-plugin-settings', $initialSettings);
  } 
  
}
