(function ($) {
    $.fn.fcchButton = function (options) {
        var settings = $.extend({
            messagePlaceholder: "Please select an option or ask me anything!",
            size: '72px',
            buttonIconBackgroundColor: '#FFFFFF',
            chatBackgroundColor: '#E5DDD5',
            position: 'right',
            popupMessage: 'HI2',
            linkButton: false,
            showPopup: true,
            showOnIE: true,
            autoOpenTimeout: 0,
            headerColor: '#25d366',
            zIndex: 0,
            buttonImage: '',
            chatbot_sid: '',
            conv_id: makeid(25),
            chatTitle: "Virtual Assistant",
            chatSubtitle: "Welcome!",
            showInHover:false,
            chatBotAvatar: ''
        }, options);

        var isMobile = mobilecheck();
        
        var buttonImageIcon = new Image();
        buttonImageIcon.src = settings.buttonImage;

        //set the .fcch-button default class
        this.addClass('fcch-button');

        //#region jQuery Elements
        var $button = $(document.createElement('div'));
        var $buttonImageContainer = $(document.createElement('div'));
        var $popup = $(document.createElement('div'));
        var $header = $(document.createElement('div'));
        var $messagesContainer = $(document.createElement('div'));
        var $btnSend = $(document.createElement('div'));
        var $inputMessage = $(document.createElement('div'));
        //#endregion
        
        //Header elements
        var $closeButton = $(document.createElement('div'));
        $closeButton.addClass('drfHxL');
        $closeButton.append('<a class="close-chatbox" aria-label="Close"><span aria-hidden="true">&#88;</span></a>');
        var $thumbContainer = $(document.createElement('div'));
        $thumbContainer.addClass('eZEgcx');
        $thumbContainer.html('<div class="izlSME"><div style="background-image: url('+settings.chatBotAvatar+');" class="lngbRu"></div></div>');
        var $headerTextContainer = $(document.createElement('div'));
        $headerTextContainer.addClass('hhASjW');
        $headerTextContainer.html('<div class="hDGnqR">'+settings.chatTitle+'</div><div class="ioFWLq">'+settings.chatSubtitle+'</div>');
        $header.append($thumbContainer, $headerTextContainer);
        
        $buttonImageContainer.addClass('fcch-button-button-image');

        $button.addClass('fcch-button-button')
            .append($(buttonImageIcon))
            .css({
                'width': settings.size,
                'height': settings.size,
                'background-color': settings.buttonIconBackgroundColor
            });
            
        if (!isInternetExplorer() || settings.showOnIE) {
            $button.append($buttonImageContainer).appendTo(this);
        }

        $button.on('click', function () {
          
            if($(".fcch-button-popup").hasClass('active')){
              $(".fcch-button-popup").removeClass('active');
              return false;
            }
          
            if (isMobile && settings.showPopup) {
                openPopup();
            }else if(settings.linkButton){
                sendChatbotMessage();
            }
           
        });
        
        $messagesContainer.on('click', '.go_word', function(e){
          sendInputFromClick($(this).html(), $(this).closest('div').attr('topic'));
        });
        //#endregion

        if (settings.showPopup) {
            var $textarea = $(document.createElement('textarea'));
            $textarea.attr('name', 'text_input');
            $textarea.attr('id', 'text_input');
            var $closeBtn = $(document.createElement('strong'));
            var $sendIcon = $('<?xml version="1.0" encoding="UTF-8" standalone="no"?><svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" style="isolation:isolate" viewBox="0 0 20 18" width="20" height="18"><defs><clipPath id="_clipPath_fgX00hLzP9PnAfCkGQoSPsYB7aEGkj1G"><rect width="20" height="18"/></clipPath></defs><g clip-path="url(#_clipPath_fgX00hLzP9PnAfCkGQoSPsYB7aEGkj1G)"><path d=" M 0 0 L 0 7.813 L 16 9 L 0 10.188 L 0 18 L 20 9 L 0 0 Z " fill="rgb(46,46,46)"/></g></svg>')

            $popup.addClass('fcch-button-popup');
            $header.addClass('fcch-button-head');
            $messagesContainer.addClass('fcch-messages-container');
            $inputMessage.addClass('fcch-button-input-message');
            $btnSend.addClass('fcch-button-btn-send');

            $textarea.attr("placeholder", settings.messagePlaceholder);
            $header.css('background-color', settings.headerColor);
            $popup.css('background-color', settings.chatBackgroundColor);

            $btnSend.append($sendIcon);
            $inputMessage.append($textarea, $btnSend);

            $closeBtn.addClass('close').html('&times;');
            
            $popup.append(
                $closeButton,
                $header,
                $messagesContainer,
                $inputMessage)
                .appendTo(this);

            /*
            $header.click(function () {
                $popup.removeClass('active');
            });
            */

            $textarea.keypress(function (event) {
                if (event.keyCode == 13 && !event.shiftKey && !isMobile) {
                  if($textarea.val() == ''){
                    return false;
                  }
                    event.preventDefault();
                    $btnSend.click();
                }
            });

            $btnSend.click(function () {
                sendChatbotMessage();
            });

            this.mouseenter(function () {
              if(settings.showInHover){
                  openPopup();
              }
            });
            
            this.click(function () {
              if(settings.showInHover == false){
                  openPopup();
              }
            });

            if (settings.autoOpenTimeout > 0) {
                setTimeout(function () {
                    openPopup();
                }, settings.autoOpenTimeout);
            }

            function openPopup() {
                if (!$popup.hasClass('active')) {
                    $popup.addClass('active');
                    $textarea.focus();
                }
            }
            
            $(".close-chatbox").click(function () {
                $popup.removeClass('active');
                return false;
            });
            
            
        }

        if (settings.zIndex) {
            $(this).css('z-index', settings.zIndex);
        }

        if (settings.position === 'right') {
            this.css({
                left: 'auto',
                right: '15px'
            });
            $popup.css('right', '0');
        }
        //#endregion
        
        function initChatbot() {
          
          //$messagesContainer.append( $('.loading-icon').clone().removeClass('hide') );
          
          $.get('https://firstcontactchatbots.com/api/chatbotapi/aimlva/'+settings.chatbot_sid+'/'+settings.conv_id, function(data){          
          //$.get('http://127.0.0.1:8000/api/chatbotapi/aimlva/'+settings.chatbot_sid+'/'+settings.conv_id, function(data){
          //Change this url accordingly to the final url will be used  
            
            var b = JSON.parse(data);
            var html = $.parseHTML(b);
            //$(".loading-icon").remove();
            
            var messageBubbleChatbot = $(document.createElement('div'));
            messageBubbleChatbot.addClass('fcch-button-message-chatbot');
            messageBubbleChatbot.html(b.response);
            messageBubbleChatbot.attr('topic', b.topic);
            $messagesContainer.append(messageBubbleChatbot);
            $messagesContainer.scrollTop($messagesContainer.prop("scrollHeight"));
          });
        }
        
        function sendChatbotMessage() {
          var input = $("#text_input").val();
          $("#text_input").val('');
          
          var messageBubble = $(document.createElement('div'));
          messageBubble.addClass('fcch-button-message');
          messageBubble.html(input);
          $messagesContainer.append(messageBubble);
          
          var messageBubbleChatbot = $(document.createElement('div'));
          messageBubbleChatbot.addClass('fcch-button-message-chatbot');
          messageBubbleChatbot.html('<div class="typing"><div class="dot"></div><div class="dot"></div><div class="dot"></div></div>');
          $messagesContainer.append(messageBubbleChatbot);
          
          $messagesContainer.animate({ scrollTop:$messagesContainer.prop("scrollHeight")}, 800);
          
          var post_data = {'input':input, 'chatbot_sid': settings.chatbot_sid, 'conv_id':settings.conv_id};
          var url = 'https://firstcontactchatbots.com/api/chatbotapi/sendChatbotMessage';
          //var url = 'http://127.0.0.1:8000/api/chatbotapi/sendChatbotMessage';
          
          $.ajax({
            url: url, 
            type: 'POST',
            data: post_data,
            cache: false,
            success: function(data){
              var datParsed = JSON.parse(data);
              var b = datParsed.response; 
              messageBubbleChatbot.html(b);
              var html = messageBubbleChatbot;
              $(html).children('a').each(function(elementIndex){
                if($(this).is( "a" )){
                  if(!$(this).html().trim()){
                    $(this).addClass('hide-fcch');
                  }
                }
              });
              $messagesContainer.append(html);
              $messagesContainer.animate({ scrollTop:$messagesContainer.prop("scrollHeight")}, 800);

            }
          });
        }
        
        function sendInputFromClick(input, topic){
                    
          $messagesContainer.append('<div class="fcch-button-message">'+input+'</div>');
          $messagesContainer.animate({ scrollTop:$messagesContainer.prop("scrollHeight")}, 800);
          if(topic === undefined){
            topic = "";
          }
          
          var messageBubbleChatbot = $(document.createElement('div'));
          messageBubbleChatbot.addClass('fcch-button-message-chatbot');
          messageBubbleChatbot.html('<div class="typing"><div class="dot"></div><div class="dot"></div><div class="dot"></div></div>');
          $messagesContainer.append(messageBubbleChatbot);
          
          $messagesContainer.animate({ scrollTop:$messagesContainer.prop("scrollHeight")}, 800);
          
          var post_data = {'input':input, 'chatbot_sid': settings.chatbot_sid, 'conv_id':settings.conv_id, 'topic':topic};
          var url = 'https://firstcontactchatbots.com/api/chatbotapi/sendChatbotMessage';
          //var url = 'http://127.0.0.1:8000/api/chatbotapi/sendChatbotMessage';
          
          $.ajax({
            url: url, 
            type: 'POST',
            data: post_data,
            cache: false,
            success: function(data){
              var datParsed = JSON.parse(data);
              var b = datParsed.response; 
              messageBubbleChatbot.html(b);
              messageBubbleChatbot.attr('topic', datParsed.topic);
              var html = messageBubbleChatbot;
              $(html).children('a').each(function(elementIndex){
                console.log("in");
                if($(this).is( "a" )){
                  if(!$(this).html().trim()){
                    $(this).addClass('hide-fcch');
                  }
                }
              });
              $messagesContainer.append(html);
              $messagesContainer.animate({ scrollTop:$messagesContainer.prop("scrollHeight")}, 800);
              
            }
          });
        }
        
        initChatbot();
        
    }

    function isInternetExplorer() {
        var userAgent = window.navigator.userAgent;
        return userAgent.indexOf("MSIE") >= 0 || userAgent.match(/Trident.*rv\:11\./);
    }

    function mobilecheck() {
        var check = false;
        (function (a) { if (/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(a) || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0, 4))) check = true; })(navigator.userAgent || navigator.vendor || window.opera);
        return check;
    }
    
    function makeid(length) {
       var result           = '';
       var characters       = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
       var charactersLength = characters.length;
       for ( var i = 0; i < length; i++ ) {
          result += characters.charAt(Math.floor(Math.random() * charactersLength));
       }
       return result;
    }
    
}(jQuery));

jQuery("#fcchChatbotWidget").fcchButton({
  messagePlaceholder:"",
  showInHover:false,
  buttonImage: fcch_array_params.image_url,
  chatBotAvatar: fcch_array_params.chatbot_avatar,
  chatbot_sid: fcch_array_params.chatbot_sid,
  headerColor: fcch_array_params.panel_color
});