<div class="wrap">
  <h1>Welcome to First Contact Chatbots!</h1>
  <p><strong>To embed a chatbot in your WordPress page is very easy!</strong></p>
  <p>First create a chatbot at <a class="add-new-h2" target="_blank" href="<?php echo esc_url("https://firstcontactchatbots.com"); ?>">https://firstcontactchatbots.com</a></p>
  <p>Next just copy and paste here the ID number of the chatbot you just created (see image below) provided at <a target="_blank" href="<?php echo esc_url("https://firstcontactchatbots.com/home"); ?>">https://firstcontactchatbots.com/home</a></p>
  
  <img src="<?php echo plugin_dir_url( __FILE__ ) . 'button_desc.png';?>" style="height:250px;">
  
  <p>
    <strong>Customize the appearence of your chatbot box (optional):</strong>
  </p>
  <p>
    You can change the button image, avatar image and the color of the chat box container.
  </p>
  <p>
    *For the button image provide a valid http resource. In example: https://yoursite/images/nice_button_image.png
  </p>
  <p>
    *For the avatar image provide a valid http resource. In example: https://yoursite/images/nice_avatar_image.png
  </p>
  <p>
    *For the color of the chat box, provide a valid HTML code color. In example: #25d366
  </p>
  
  <div class="metabox-holder columns-2">
    <div class="postbox">
      <div class="inside">
        <form action="options.php" method="post">
          
          <?php
          settings_fields('fcch-settings-group');
          $settings = get_option('fcch-plugin-settings');
          $chatbotId = (array_key_exists('chatbotId', $settings) ? $settings['chatbotId'] : '');
          $imageUrl = (array_key_exists('imageUrl', $settings) ? $settings['imageUrl'] : '');
          $chatbotAvatar = (array_key_exists('chatbotAvatar', $settings) ? $settings['chatbotAvatar'] : '');
          $panelColor = (array_key_exists('panelColor', $settings) ? $settings['panelColor'] : '');
          $showOn = (array_key_exists('showOn', $settings) ? $settings['showOn'] : 'all');
          ?>

          <h3 class="cc-labels">HTML code:</h3>
          <table style="width:70%;">
            <tr>
              <td style="width:23%;">
                <label style="float: right;">Chatbot ID (required): </label>
              </td>
              <td style="width:77%;">
                <input type="text" required="required" style="width:100%;" id="fcch_chatbot_id" name="fcch-plugin-settings[chatbotId]" value="<?php echo esc_html($chatbotId); ?>" />
              </td>
            </tr>
            <tr>
              <td>
                <label style="float: right;">Button image URL: </label>
              </td>
              <td>
                <input type="text" style="width:100%;" id="fcch_chatbot_url" name="fcch-plugin-settings[imageUrl]" value="<?php echo esc_html($imageUrl); ?>" placeholder="https://yourimagesite..." />
              </td>
            </tr>
            <tr>
              <td>
                <label style="float: right;">Chatbot avatar image: </label>
              </td>
              <td>
                <input type="text" style="width:100%;" id="fcch_chatbot_avatar" name="fcch-plugin-settings[chatbotAvatar]" value="<?php echo esc_html($chatbotAvatar); ?>" placeholder="https://yourimagesite..." />
              </td>
            </tr>
            <tr>
              <td>
                <label style="float: right;">Panel color: </label>
              </td>
              <td>
                <input type="text" style="width:100%;" id="fcch_chatbot_panel_color" name="fcch-plugin-settings[panelColor]" value="<?php echo esc_html($panelColor); ?>" placeholder="#yourcodecolor" />
              </td>
            </tr>
          </table>
          <br>
          <input type="radio" name="fcch-plugin-settings[showOn]" value="all" id="all" <?php checked('all', $showOn); ?>> <label>Show chabot everywhere in the website</label> 
          <br>
          <input type="radio" name="fcch-plugin-settings[showOn]" value="home" id="home" <?php checked('home', $showOn); ?>> <label>Show chabot in homepage only</label> 
          
          <p class="submit">
            <input class="button button-primary" type="submit" name="Submit" value="Save"  style="padding: 0px 30px;font-size:15px;background-color: #2c6ac3;border-color: #2c6ac3;"/>
          </p>

        </form>
      </div>
    </div>
  </div>
  
</div>